import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;
import java.util.Random;


public class Main
{
	public static void main(String[] arg) throws Exception
	{
		// jesli wczesniej cos zapisalem [odpalam program po raz kolejny] to wczytaj to co bylo
		// DEMONSTRACJA DZIALANIA 'TRWALYCH EKSTENSJI' (trwale czyli nie znikaja po zamnieciu programu)
		if(new File("mojeTajneDane").isFile())
		{
			try
			{
				// plik jest w 'workspace'
				FileInputStream fileIn = new FileInputStream("mojeTajneDane");
				ObjectInputStream inStream = new ObjectInputStream(fileIn);
				// odczytuje wszystko z dysku do pliku 'mojeTajneDane' jedna linijka
				// 'magia javy' zrobi reszte
				ObjectPlus.odczytajEkstensje(inStream);
				inStream.close();
				fileIn.close();
			}
			catch(IOException i)
			{
				i.printStackTrace();
				return;
			}
			catch(ClassNotFoundException c)
			{
				System.out.println("Klasa nie znaleziona.");
				c.printStackTrace();
				return;
			}
		}
		
		
		
		// utworz nowego Grzegorza o wzroscie miedzy 165, a 195
		Random rand = new Random();
		Student studencik = new Student("Grzegorz" + rand.nextInt(100), 165 + (rand.nextInt(31)));
		// na date urodzenia ustawiamy czas jaki jest 'teraz'
		studencik.ustawDateUrodzenia(new Date());
		// wywoluje przeciazana metode z parametrem 'int'
		studencik.dodajOcene(2 + rand.nextInt(4));
		// wywoluje przeciazana metode z parametrem 'Double'
		studencik.dodajOcene(new Double(2 + ((double)rand.nextInt(7) / 2)));
		// pokaz wszystkich Grzegorzy jacy istnieja
		ObjectPlus.pokazEkstensje(Student.class);
		
		
		
		// przed zamknieciem programu zapisz wszystkie ekstensje do pliku
		// DEMONSTRACJA DZIALANIA 'TRWALYCH EKSTENSJI' (trwale czyli nie znikaja po zamnieciu programu)
		try
		{
			// plik jest w 'workspace'
			FileOutputStream fileOut = new FileOutputStream("mojeTajneDane");
			ObjectOutputStream outStream = new ObjectOutputStream(fileOut);
			// zapisuje wszystko na dysk do pliku 'mojeTajneDane' jedna linijka
			// 'magia javy' zrobi reszte
			ObjectPlus.zapiszEkstensje(outStream);
			outStream.close();
			fileOut.close();
		}
		catch(IOException i)
		{
			i.printStackTrace();
		}
		
	}
}
